﻿Imports System.Data.SQLite

Public Class frmMain

    Dim blnDoingWork As Boolean = False
    Dim strFileName As String = String.Empty


    '自动搜寻按钮
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'HKEY_CLASSES_ROOT\Local Settings\Software\Microsoft\Windows\Shell\MuiCache
        '深圳市迅雷网络技术有限公司
        Dim localPath As String = String.Empty
        Dim Key As Microsoft.Win32.RegistryKey = My.Computer.Registry.ClassesRoot.OpenSubKey("Local Settings\Software\Microsoft\Windows\Shell\MuiCache")
        Dim lstItem() As String = Key.GetValueNames
        For Each tmpStr As String In lstItem
            If tmpStr.EndsWith("Thunder.exe.ApplicationCompany") Then
                localPath = tmpStr.Substring(0, tmpStr.LastIndexOf("\"))
                localPath = localPath.Substring(0, localPath.LastIndexOf("\"))
                localPath = localPath & "\Profiles\TaskDb.dat"
                Exit For
            End If
        Next
        If System.IO.File.Exists(localPath) Then
            MsgBox("自动定位成功，可直接点击一键打开通道执行", MsgBoxStyle.DefaultButton1, "友情提示")
            Me.TextBox1.Text = localPath
        Else
            MsgBox("自动定位失败，请尝试手工定位数据库（TaskDb.dat）文件", MsgBoxStyle.DefaultButton1, "友情提示")
        End If


    End Sub

    '浏览按钮
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        MsgBox("请找到迅雷本地的安装目录，并且选中TaskDb.dat这个文件。" & vbCr & "例：C:\Program Files (x86)\Thunder Network\Thunder\Profiles\TaskDb.dat", MsgBoxStyle.DefaultButton1, "友情提示")
        Dim intResult As Integer = OpenFileDialog1.ShowDialog()
        If intResult = 1 Then
            Me.TextBox1.Text = OpenFileDialog1.FileName
        End If

    End Sub


    '一键打开通道按钮
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        If blnDoingWork Then
            MsgBox("正在处理中，请稍候...", MsgBoxStyle.Exclamation + MsgBoxStyle.OkOnly, "友情提示")
            Return
        End If
        strFileName = Me.TextBox1.Text
        If strFileName.Equals(String.Empty) Then
            MsgBox("数据文件尚未定位，请自动或手工定位文件", MsgBoxStyle.Exclamation + MsgBoxStyle.OkOnly, "友情提示")
            Return
        End If
        BackgroundWorker1.RunWorkerAsync()
        'BackgroundWorker1_DoWork(Nothing, Nothing)
    End Sub



    Dim intReturnCode As Integer = -1
    '数据库更新主逻辑
    Private Sub BackgroundWorker1_DoWork(ByVal sender As Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        blnDoingWork = True
        intReturnCode = -1
        If strFileName.Equals(String.Empty) Then
            Return
        End If
        If Not System.IO.File.Exists(strFileName) Then
            Return
        End If
        Try
            '初期化
            Dim conn As SQLiteConnection
            conn = New SQLiteConnection("Data Source=" & strFileName & ";Pooling=true;FailIfMissing=false")
            '数据库打开
            If conn.State <> ConnectionState.Open Then
                conn.Open()
            End If
            '所有表名获得并定位
            Dim tmpDataTable As New System.Data.DataTable
            Dim tmpSA As New SQLiteDataAdapter("SELECT name FROM sqlite_master WHERE type='table' ORDER BY name", conn)
            Dim tmpDataSet As New System.Data.DataSet
            'AccelerateTaskMap119389482_superspeed_1_1
            tmpSA.Fill(tmpDataSet, "TableNames")
            tmpDataTable = tmpDataSet.Tables("TableNames")

            For Each tmpRow As DataRow In tmpDataTable.Rows
                Dim tmpTableName As String = tmpRow.Item(0)
                If tmpTableName.StartsWith("AccelerateTaskMap") AndAlso tmpTableName.IndexOf("superspeed") > 0 Then

                    Dim tmpInfoTable As New System.Data.DataTable
                    Dim tmpInfoSA As New SQLiteDataAdapter("SELECT LocalTaskId,UserData FROM " & tmpTableName, conn)
                    Dim tmpInfoSet As New System.Data.DataSet
                    tmpInfoSA.Fill(tmpInfoSet, "Infos")
                    tmpInfoTable = tmpInfoSet.Tables("Infos")
                    For Each tmpInfoRow As DataRow In tmpInfoTable.Rows

                        '{"CommitGcid":"","Message":"该资源被举报，无法添加到高速通道","Result":508,"SubId":0}


                        Dim enc As System.Text.Encoding = System.Text.Encoding.UTF8
                        Dim oldInfo As Byte() = tmpInfoRow(1)

                        Dim tmpUserData As String = enc.GetString(tmpInfoRow(1))
                        If (tmpUserData.IndexOf("""Result"":509") > 0) Then
                            tmpUserData = tmpUserData.Replace("""Result"":509", """Result"":0")
                        ElseIf (tmpUserData.IndexOf("""Result"":508") > 0) Then
                            tmpUserData = tmpUserData.Replace("""Result"":508", """Result"":0")
                        End If
                        Dim newInfo As Byte() = enc.GetBytes(tmpUserData)

                        Dim cmd As New SQLiteCommand
                        cmd = conn.CreateCommand()
                        cmd.CommandText = "UPDATE " & tmpTableName & " SET UserData=@data1 Where UserData = @data2"
                        cmd.Parameters.Add("@data1", Data.DbType.Binary).Value = newInfo
                        cmd.Parameters.Add("@data2", Data.DbType.Binary).Value = oldInfo
                        Dim intReult As Integer = cmd.ExecuteNonQuery()
                        If intReult <> 0 Then

                        End If
                    Next
                End If
            Next

            conn.Close()

            intReturnCode = 0
        Catch ex As Exception
            Return
        End Try
    End Sub


    Private Sub BackgroundWorker1_RunWorkerCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles BackgroundWorker1.RunWorkerCompleted
        If (intReturnCode = 0) Then
            MsgBox("处理成功完成！见证奇迹吧，骚粘！", MsgBoxStyle.OkOnly, "友情提示")
        Else
            MsgBox("失败鸟...", MsgBoxStyle.Exclamation + MsgBoxStyle.OkOnly, "友情提示")
        End If
        blnDoingWork = False
    End Sub
End Class
